<template>
    <div class="h-full flex">
        <div class="m-auto w-96 max-w-full">
            <div class="justify-center p-3">
                <div class="text-center pb-6 text-2xl">Регистрация</div>
                <div class="grid gap-4">
                    <QuestTextField
                        :errors="errors.email"
                        autofocus
                        autocomplete="new-email"
                        placeholder="Email"
                        email
                        v-model="registerData.email"
                    /><br />
                    <QuestTextField
                        :errors="errors.name"
                        placeholder="Имя пользователя"
                        autocomplete="new-name"
                        v-model="registerData.name"
                    /><br />
                    <QuestTextField
                        :errors="errors.password"
                        autocomplete="new-password"
                        placeholder="Пароль"
                        v-model="registerData.password"
                        password
                    /><br />

                    <QuestBtn
                        @click="registerUser"
                        :disabled="!isValid || loading"
                    >
                        Зарегистрироваться</QuestBtn
                    ><br />

                    <router-link :to="{ name: 'Welcome' }"
                        ><span class="text-gray-600">Главная</span></router-link
                    >
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { mapActions } from "vuex";
import { prepErrors } from "@/utils";
import QuestTextField from "@/components/QuestTextField";
import QuestBtn from "@/components/QuestBtn";

const initialRegisterData = {
    email: "",
    name: "",
    password: "",
};

export default {
    name: "Register",
    components: { QuestBtn, QuestTextField },
    data: () => ({
        registerData: { ...initialRegisterData },
        errors: { email: [], password: [], name: [] },
        loading: false,
    }),
    methods: {
        ...mapActions("app", ["register"]),
        async registerUser() {
            try {
                this.loading = true;

                await this.register(this.registerData);

                await this.$router.push({ name: "Welcome" });
            } catch (e) {
                this.errors = prepErrors(e);
                this.loading = false;
            }
        },
    },
    computed: {
        isValid() {
            const { email, name, password } = this.registerData;
            return email && name && password;
        },
    },
};
</script>

<style scoped></style>
